﻿''' <summary>
''' コマンドパッド
''' </summary>
''' <remarks></remarks>
Public Class FormCommandPad

    ''' <summary>
    ''' コマンドイベント
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Public Event Action(sender As Object, e As CommandEventArgs)



    '===========================================================================================================



    Private Const WS_EX_NOACTIVATE As Integer = &H8000000

    Protected Overrides ReadOnly Property CreateParams() As CreateParams

        Get
            '=== 非アクティブ化 ===
            'Microsoftによると、これだけでアクティブ化しないフォームになるみた。仕組みは、知らない。

            Dim p As CreateParams = MyBase.CreateParams
            If Not MyBase.DesignMode Then
                p.ExStyle = p.ExStyle Or (WS_EX_NOACTIVATE)
            End If
            Return p
        End Get

    End Property



    '===========================================================================================================



    Private Sub FormCommandPad_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

        '=== フォームの設定 ===
        '--- 不透明度 ---
        Me.Opacity = SettingData.CommandPad.Opacity

        '--- 形状 ---
        Using grpPath As New Drawing2D.GraphicsPath
            grpPath.AddLines(New Point() {btnCopyView.Location, btnCopyView.Location + New Size(btnCopyView.Width, 0),
                                          btnOriginReset.Location + New Size(btnOriginReset.Width, 0), btnOriginReset.Location + New Size(btnOriginReset.Width, btnOriginReset.Height),
                                          btnGotoOrigin.Location + New Size(btnGotoOrigin.Width, btnGotoOrigin.Height), btnGotoOrigin.Location + New Size(0, btnGotoOrigin.Height),
                                          btnGetColor.Location + New Size(0, btnGetColor.Height), btnGetColor.Location})
            Me.Region = New Region(grpPath)
        End Using

        '=== コマンドパッドの要請内容を設定 ===
        btnOriginSet.Tag = CommandEventArgs.Requests.OriginSet
        btnOriginReset.Tag = CommandEventArgs.Requests.OriginReset
        btnGotoOrigin.Tag = CommandEventArgs.Requests.GotoOrigin
        btnGetColor.Tag = CommandEventArgs.Requests.GetColor
        btnCopyView.Tag = CommandEventArgs.Requests.CopyView

    End Sub

    Private Sub FormCommandPad_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        '=== ユーザ操作による終了（例えば、[Alt]+[F4]）を却下 ===
        If e.CloseReason = CloseReason.UserClosing Then
            e.Cancel = True
        End If

    End Sub

    Private Sub CommandButton_Click(sender As System.Object, e As System.EventArgs) Handles btnOriginSet.Click, btnOriginReset.Click, btnGotoOrigin.Click, btnGetColor.Click, btnCopyView.Click

        '=== コマンドイベント発生 ===
        RaiseEvent Action(Me, New CommandEventArgs(DirectCast(sender, Button).Tag))

    End Sub

End Class





'|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||





''' <summary>
''' コマンドイベント内容
''' </summary>
''' <remarks></remarks>
Public Class CommandEventArgs

    Inherits EventArgs

    ''' <summary>
    ''' 要請一覧
    ''' </summary>
    ''' <remarks></remarks>
    Public Enum Requests As Byte

        ''' <summary>未指定</summary>
        [Nothing]

        ''' <summary>原点設定</summary>
        OriginSet

        ''' <summary>原点復帰</summary>
        OriginReset

        ''' <summary>原点出向</summary>
        GotoOrigin

        ''' <summary>色取得</summary>
        GetColor

        ''' <summary>拡大像複写</summary>
        CopyView

    End Enum



    '===========================================================================================================



    Private _Request As Requests

    ''' <summary>
    ''' 要請内容
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property Request As Requests
        Get
            Return _Request
        End Get
    End Property



    '===========================================================================================================



    ''' <summary>
    ''' コンストラクタ
    ''' </summary>
    ''' <param name="Request">要請内容</param>
    ''' <remarks></remarks>
    Public Sub New(Request As Requests)

        _Request = Request

    End Sub

End Class