﻿''' <summary>
''' 情報パネル
''' </summary>
''' <remarks></remarks>
Public Class FormInformationPanel

    ''' <summary>
    ''' 形式
    ''' </summary>
    ''' <remarks></remarks>
    Public Enum LooksStyle As Byte

        ''' <summary>なし</summary>
        Unvisible

        ''' <summary>八つ橋</summary>
        Bar

        ''' <summary>きんつば</summary>
        Square

        ''' <summary>芋けんぴ</summary>
        Twig

        ''' <summary>金平糖</summary>
        mini

    End Enum


    '-----------------------------------------------------------------------------------------------------------


    ''' <summary>
    ''' 形式パターン
    ''' </summary>
    ''' <remarks></remarks>
    Public Structure LooksPattern

        ''' <summary>呼称</summary>
        Public Property Caption As String

        ''' <summary>外観</summary>
        Public Property Style As LooksStyle

    End Structure


    '-----------------------------------------------------------------------------------------------------------


    ''' <summary>
    ''' 用意された形式のコレクション
    ''' </summary>
    ''' <remarks>設定コンソールの[ComboBox]用</remarks>
    Public ReadOnly PreparedLooks As List(Of LooksPattern) = {New LooksPattern With {.Caption = "表示しない", .Style = LooksStyle.Unvisible},
                                                              New LooksPattern With {.Caption = "八つ橋", .Style = LooksStyle.Bar},
                                                              New LooksPattern With {.Caption = "きんつば", .Style = LooksStyle.Square},
                                                              New LooksPattern With {.Caption = "芋けんぴ", .Style = LooksStyle.Twig},
                                                              New LooksPattern With {.Caption = "金平糖", .Style = LooksStyle.mini}}.ToList



    '===========================================================================================================



    Private Sub FormInfomation_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown

        '=== 最初の表示位置を決める ===
        MoveLocate()

    End Sub

    Private Sub FormInformationPanel_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        '=== ユーザ操作による終了（例えば、[Alt]+[F4]）を却下 ===
        If e.CloseReason = CloseReason.UserClosing Then
            e.Cancel = True
        End If

    End Sub

    ''' <summary>
    ''' 形式の変更
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub StyleChange()

        If SettingData.Lupe.InformationPanel.Style = LooksStyle.Unvisible Then

            '=== 非表示 ===
            Me.Hide()

        Else

            '=== 形式変更 ===
            Select Case SettingData.Lupe.InformationPanel.Style

                Case LooksStyle.Bar

                    '--- 八つ橋 ---
                    lblRed.Size = New Size(61, 14)
                    lblRed.Location = New Point(0, 0)

                    lblGreen.Size = New Size(61, 14)
                    lblGreen.Top = lblRed.Top
                    lblGreen.Left = lblRed.Left + lblRed.Width

                    lblBlue.Size = New Size(61, 14)
                    lblBlue.Top = lblGreen.Top
                    lblBlue.Left = lblGreen.Left + lblGreen.Width

                    lblLocate.Top = lblBlue.Top + 1
                    lblLocate.Left = lblBlue.Left + lblBlue.Width + 1
                    lblLocate.Visible = True

                    lblOrigin.Size = New Size(139, 14)
                    lblOrigin.Top = lblLocate.Top + lblLocate.Height
                    lblOrigin.Left = lblLocate.Left + lblLocate.Width - lblOrigin.Width

                    lblMath.Size = New Size(117, 14)
                    lblMath.Top = lblRed.Top + lblRed.Height + 1
                    lblMath.Left = lblRed.Left
                    lblMath.Visible = True

                Case LooksStyle.Square

                    '--- きんつば ---
                    lblRed.Size = New Size(61, 14)
                    lblRed.Location = New Point(0, 0)

                    lblGreen.Size = New Size(61, 14)
                    lblGreen.Top = lblRed.Top + lblRed.Height
                    lblGreen.Left = lblRed.Left

                    lblBlue.Size = New Size(61, 14)
                    lblBlue.Top = lblGreen.Top + lblGreen.Height
                    lblBlue.Left = lblGreen.Left

                    lblLocate.Top = lblRed.Top
                    lblLocate.Left = lblRed.Left + lblRed.Width + 1
                    lblLocate.Visible = True

                    lblOrigin.Size = New Size(73, 14)
                    lblOrigin.Top = lblLocate.Top + lblLocate.Height
                    lblOrigin.Left = lblLocate.Left

                    lblMath.Size = New Size(73, 14)
                    lblMath.Top = lblOrigin.Top + lblOrigin.Height
                    lblMath.Left = lblOrigin.Left
                    lblMath.Visible = True

                Case LooksStyle.Twig

                    '--- 芋けんぴ ---
                    lblRed.Size = New Size(19, 14)
                    lblRed.Location = New Point(0, 0)

                    lblGreen.Size = New Size(19, 14)
                    lblGreen.Top = lblRed.Top
                    lblGreen.Left = lblRed.Left + lblRed.Width

                    lblBlue.Size = New Size(19, 14)
                    lblBlue.Top = lblGreen.Top
                    lblBlue.Left = lblGreen.Left + lblGreen.Width

                    lblLocate.Visible = False

                    lblOrigin.Size = New Size(73, 14)
                    lblOrigin.Top = lblRed.Top
                    lblOrigin.Left = lblBlue.Left + lblRed.Width

                    lblMath.Visible = False

                Case LooksStyle.mini

                    '--- 金平糖 ---
                    lblRed.Size = New Size(19, 14)
                    lblRed.Location = New Point(0, 0)

                    lblGreen.Size = New Size(19, 14)
                    lblGreen.Top = lblRed.Top
                    lblGreen.Left = lblRed.Left + lblRed.Width

                    lblBlue.Size = New Size(19, 14)
                    lblBlue.Top = lblGreen.Top
                    lblBlue.Left = lblGreen.Left + lblGreen.Width

                    lblLocate.Visible = False

                    lblOrigin.Size = New Size(73, 14)
                    lblOrigin.Top = lblRed.Top + lblRed.Height
                    lblOrigin.Left = lblRed.Left

                    lblMath.Visible = False

            End Select

            '=== 表示位置調整 ===
            MoveLocate()
            Me.Show()

        End If

    End Sub

    ''' <summary>
    ''' オーナー（ビューア）の周囲を回り込む
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub MoveLocate()

        With Screen.GetWorkingArea(Owner)

            Dim x, y As Integer

            Select Case SettingData.Lupe.Avoid.Mode

                Case FormMain.AvoidType.Passive, FormMain.AvoidType.ScreenSide

                    '=== 手動・左右 ===
                    If Owner.Left > .Left + (.Width - Owner.Width) \ 2 Then 'オーナーが画面右半分に入っている？
                        x = Owner.Left + Owner.Width - Me.Width 'オーナーの右端に合わせる
                    Else
                        x = Owner.Left 'オーナーの左端に合わせる
                    End If

                    If .Bottom - Owner.Top - Owner.Height > Me.Height Then '画面下端に余裕がある？
                        y = Owner.Top + Owner.Height 'オーナーの下側
                    Else
                        y = Owner.Top - Me.Height 'オーナーの上側
                    End If

                Case FormMain.AvoidType.RightTriangle

                    '=== 三角 ===
                    If Owner.Left > .Left + (.Width - Owner.Width) \ 2 Then 'オーナーが画面右半分に入っている？
                        x = Owner.Left + Owner.Width - Me.Width 'オーナーの右端に合わせる
                        y = Owner.Top + Owner.Height 'オーナーの下側
                    Else
                        x = Owner.Left - Me.Width 'オーナーの左側
                        If Owner.Top > .Top + (.Height - Owner.Height) \ 2 Then 'オーナーが画面下半分に入っている？
                            y = Owner.Top + Owner.Height - Me.Height 'オーナーの下端に合わせる
                        Else
                            y = Owner.Top 'オーナーの上端に合わせる
                        End If
                    End If

                Case FormMain.AvoidType.ScreenCorner

                    '=== 四隅 ===
                    If .Right - Owner.Left - Owner.Width > Me.Width Then '画面右端に余裕がある？
                        x = Owner.Left + Owner.Width 'オーナーの右側
                    Else
                        x = Owner.Left - Me.Width 'オーナーの左側
                    End If

                    If Owner.Top > .Top + (.Height - Owner.Height) \ 2 Then 'オーナーが画面下半分に入っている？
                        y = Owner.Top + Owner.Height - Me.Height 'オーナーの下端に合わせる
                    Else
                        y = Owner.Top 'オーナーの上端に合わせる
                    End If

                Case FormMain.AvoidType.Randezvous

                    '=== 帯同 ===
                    '※マウスカーソルの座標は、ビューアの座標ではリフレッシュレートによって現実とタイムラグが生じるので、リアルタイムの座標を使用する。

                    If Owner.Left > Windows.Forms.Cursor.Position.X AndAlso .Right - Owner.Left - Owner.Width > Me.Width Then 'オーナーがマウスカーソルの右側、且つ、画面右端に余裕がある？
                        x = Owner.Left + Owner.Width 'オーナーの右側
                    Else
                        x = Owner.Left - Me.Width 'オーナーの左側
                    End If

                    If Owner.Top > Windows.Forms.Cursor.Position.Y Then 'オーナーがマウスカーソルより下にある？
                        y = Owner.Top + Owner.Height - Me.Height 'オーナーの下端に合わせる
                    Else
                        y = Owner.Top 'オーナーの上端に合わせる
                    End If

            End Select

            Me.Location = New Point(x, y)

        End With

    End Sub

    ''' <summary>
    ''' 情報を表示する
    ''' </summary>
    ''' <param name="Locate">マウスカーソル座標</param>
    ''' <param name="ColorCode">マウスカーソル位置の色コード(ARGB値)</param>
    ''' <remarks></remarks>
    Public Sub WriteParameter(Locate As Point, ColorCode As Integer)

        '=== 色要素分離 ===
        Dim argb() As Byte = DirectCast(Me.Owner, FormMain).SplitARGB(ColorCode) 'オーナー（ビューア）で色要素を分離してもらう。

        '=== 情報表示 ===
        Select Case SettingData.Lupe.InformationPanel.Style

            Case LooksStyle.Bar

                '--- 八つ橋 ---
                lblRed.Text = String.Format("R:{0:X2}({0:d3})", argb(1))
                lblGreen.Text = String.Format("G:{0:X2}({0:d3})", argb(2))
                lblBlue.Text = String.Format("B:{0:X2}({0:d3})", argb(3))

                Dim workLocate As Point = Locate
                lblLocate.Text = String.Format("({0:d4},{1:d4})", workLocate.X, workLocate.Y)

                Dim distance As Double = GetDistance_P2P(ResumeData.OriginPoint, workLocate)
                Dim angle As Double = GetAngle(ResumeData.OriginPoint, workLocate)
                lblMath.Text = String.Format("{0,7:##0.##0}° {1,8:###0.##0}", Math.Round(angle, 3, MidpointRounding.AwayFromZero), Math.Round(distance, 3, MidpointRounding.AwayFromZero))

                lblOrigin.Text = String.Format("{0,5:####0},{1,5:####0}({2:d4},{3:d4})",
                                               workLocate.X, workLocate.Y,
                                               ResumeData.OriginPoint.X, ResumeData.OriginPoint.Y)

            Case LooksStyle.Square

                '--- きんつば ---
                lblRed.Text = String.Format("R:{0:X2}({0:d3})", argb(1))
                lblGreen.Text = String.Format("G:{0:X2}({0:d3})", argb(2))
                lblBlue.Text = String.Format("B:{0:X2}({0:d3})", argb(3))

                Dim workLocate As Point = Locate
                lblLocate.Text = String.Format("({0:d4},{1:d4})", workLocate.X, workLocate.Y)

                Dim distance As Double = GetDistance_P2P(ResumeData.OriginPoint, workLocate)
                Dim angle As Double = GetAngle(ResumeData.OriginPoint, workLocate)
                lblOrigin.Text = String.Format("{0,5:####0},{1,5:####0}", workLocate.X, workLocate.Y)
                lblMath.Text = String.Format("{0,3:##0}°  {1,4:###0}", Math.Round(angle, MidpointRounding.AwayFromZero), Math.Round(distance, MidpointRounding.AwayFromZero))

            Case Else

                '--- 芋けんぴ・金平糖 ---
                lblRed.Text = String.Format("{0:X2}", argb(1))
                lblGreen.Text = String.Format("{0:X2}", argb(2))
                lblBlue.Text = String.Format("{0:X2}", argb(3))

                lblOrigin.Text = String.Format("{0,5:####0},{1,5:####0}",
                                               Locate.X - ResumeData.OriginPoint.X,
                                               Locate.Y - ResumeData.OriginPoint.Y)

        End Select

    End Sub

    ''' <summary>
    ''' 角度を求める
    ''' </summary>
    ''' <param name="Center">中心の座標</param>
    ''' <param name="Locate">角度をなす点の座標（相対座標に変換されます）</param>
    ''' <returns>中心点の右を0度として時計回りの角度を返す。</returns>
    ''' <remarks>中心点は、90度となる。</remarks>
    Private Function GetAngle(ByVal Center As Point, ByRef Locate As Point) As Double

        Dim a As Double '角度

        Locate -= Center '中心点から見た点[Locate]の相対座標

        With Locate
            If .X = 0 Then
                a = Math.PI / 2
            Else
                a = Math.Atan(.Y / .X)
                If a < 0 Then a = a + Math.PI
            End If
            If .Y < 0 OrElse (.Y = 0 AndAlso .X < 0) Then a = a + Math.PI
        End With

        a = a / Math.PI * 180 'ラジアン→1周360

        Return a

    End Function

    ''' <summary>
    ''' 2点間の距離を求める
    ''' </summary>
    ''' <param name="Point1">点1の座標</param>
    ''' <param name="Point2">点2の座標</param>
    ''' <returns>距離</returns>
    ''' <remarks></remarks>
    Public Function GetDistance_P2P(ByVal Point1 As Point, ByVal Point2 As Point) As Double

        Return Math.Sqrt((Point2.X - Point1.X) ^ 2 + (Point2.Y - Point1.Y) ^ 2)

    End Function

End Class