﻿'┌────┐
'│技術要綱├──────────────────────
'└┬───┘
'  │『拡大サイズと倍率の設定について』
'  │・《ComboBox》で規定値を選択すると共に、任意の数値を入力できるようにもできるけど（色書式の様に）、数字以外の文字が入力された場合への対処が面倒なので未対応。
'  │
'  └────────────





''' <summary>
''' 設定コンソール
''' </summary>
''' <remarks></remarks>
Public Class FormSetupConsole

    ''' <summary>更新間隔の1目盛り分</summary>
    Private Const ADJUST_INTERVAL As Integer = 50

    ''' <summary>改行の代替文字</summary>
    Private Const ENTER_STRING As String = "\n"



    '===========================================================================================================



    ''' <summary>お試し時のバックアップ用</summary>
    Private BackupSetting As SettingParameter = Nothing

    ''' <summary>入力したキーセット</summary>
    Private InputtedKey As Keys = Keys.None



    '===========================================================================================================



    Private Sub FormSetupConsole_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        '=== 初期設定 ===
        Me.Icon = My.Resources.Main
        Me.Text = My.Application.Info.Title & Me.Text

        '--- 説明文の設定 ---
        'プロパティウィンドの[hlpHelpPopupのHelpString]では、改行を含む文章を編集できなかったので、ここで設定している。
        With hlpHelpPopup

            .SetHelpString(trkRefreshInterval, String.Format("拡大鏡を更新する間隔を、{0}ミリ秒単位で指定します。", ADJUST_INTERVAL))

            .SetHelpString(cmbAreaWidth, "マウスカーソルを中心に、横何ピクセル分を拡大するかを選択します。")
            .SetHelpString(cmbAreaHeight, "マウスカーソルを中心に、縦何ピクセル分を拡大するかを選択します。")
            .SetHelpString(chkSquareArea, "縦と横を同じ値にする場合は、チェックを入れます。")

            .SetHelpString(cmbMagnification, "1ピクセルを縦横何倍して、ビューアに表示するかを選択します。")

            .SetHelpString(chkMarker, "ビューアの中央にカーソルマーカーを表示したい場合は、チェックを入れます。" & vbCrLf & "カーソルマーカーとは、マウスカーソルがある位置を示す、四角い枠のことです。")
            .SetHelpString(cbbMarker, "カーソルマーカーの色を設定します。")
            .SetHelpString(chkGrid, "ビューアに格子線を表示したい時に、チェックを入れます。" & vbCrLf & "格子線とは、各ピクセル間を区切る線のことです。")
            .SetHelpString(cbbGrid, "格子線の色を設定します。")
            .SetHelpString(chkFoundationDesign, "下地に斜線を表示したい時に、チェックを入れます。" & vbCrLf & "マウスカーソルが画面の端に行くと、拡大範囲がデスクトップからはみ出します。そのはみ出した部分に見えるのが""下地""です。")
            .SetHelpString(cbbFoundation, "下地の斜線色と背景色を設定します。" & vbCrLf & "クリックすると開くメニューから、対象を選択してください。")

            .SetHelpString(cmbInfoPanelStyle, "情報パネルの形式を選択します。" & vbCrLf & "形式によって、表示内容が異なります。")

            .SetHelpString(cmbAvoidMode, "作業の邪魔にならないように、拡大鏡がマウスカーソルを避ける方法を選択します。" & vbCrLf & "画面に対してビューアが大きい範囲を占める場合、正常に動作できない可能性があります。")

            .SetHelpString(lvwOperationKey, "操作キーに使用するキーを設定します。" & vbCrLf & "ここで変更したい項目を選択してから、下の[入力]をクリックしてください。")
            .SetHelpString(btnInputKey, "操作キーに使用するキーを入力します。" & vbCrLf & "上の一覧から選択した後、ここをクリックして望みのキーを押すと、その組み合わせが表示されます。もう一度マウスでクリックすると登録されます。" & vbCrLf & "登録する前に他の項目を選択すると、入力した内容が破棄されます。")

            .SetHelpString(lblFormatSample, "色書式の使用例を表示します。" & vbCrLf & "改行は、""" & ENTER_STRING & """と置き換えられます。")
            .SetHelpString(cmbColorFormat, "コマンドパッドから、マウスカーソル位置の色コード（ARGB値）をクリップボードへコピーする際の書式を設定します。" & vbCrLf & "規定の書式から選んだり、お好みの書式を入力したりできます。" & vbCrLf & vbCrLf & "書式は、《String.Format》メソッドに規準し、使用できる要素は以下の通りになります。" & vbCrLf & "{0}=改行, {1}=ARGB, {2}=RGB" & vbCrLf & "{3}=A, {4}=R, {5}=G, {6}=B, {7}=A(0.0F～1.0F)")

            .SetHelpString(btnDefault, "この設定画面の内容や設定ファイルの内容を、既定の値に戻します。" & vbCrLf & "設定ファイルを既定値に戻すと、現在の設定値は失われますので、十分注意して使用してください。")

            .SetHelpString(btnTry, "現在の設定内容を、試用します。" & vbCrLf & "保存されないので、[キャンセル]をクリックすれば元に戻ります。")
            .SetHelpString(btnOK, "変更した内容を確定して保存します。")
            .SetHelpString(btnCancel, "変更を破棄して、設定を終了します。[お試し]を利用している場合は、元の設定に戻ります。")

        End With

        '--- 設定項目の基本設定 ---
        '拡大鏡の更新間隔の最小調整幅
        trkRefreshInterval.Minimum = 1 '0から1に設定しなおすことで、《ValueChanged》イベントを発生させる。

        '情報パネル形式
        With cmbInfoPanelStyle
            .DisplayMember = "Caption"
            .ValueMember = "Style"
            .DataSource = FormInformationPanel.PreparedLooks
        End With

        'マウスからの回避項目
        With cmbAvoidMode
            .DisplayMember = "Caption"
            .ValueMember = "Type"
            .DataSource = DirectCast(Owner, FormMain).PreparedAvoid
        End With

        '--- 現在の設定内容を表示 ---
        DisplayParameter(SettingData)

    End Sub

    Private Sub btnDefault_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDefault.Click

        '=== デフォルト ===
        Select Case MessageBox.Show("ここの設定項目にはないものも含め、全ての内容を既定値に戻しますか？" & vbCrLf & "※全てを戻した時点で、設定ファイルが書き換わります。", Me.Text, MessageBoxButtons.YesNoCancel, MessageBoxIcon.Exclamation)

            Case Windows.Forms.DialogResult.Yes

                If MessageBox.Show("現在の設定内容を完全に失います。本当に既定値に戻しますか？", Me.Text, MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) = Windows.Forms.DialogResult.Yes Then
                    Me.DialogResult = Windows.Forms.DialogResult.OK
                    SettingData = New SettingParameter
                    Save()
                End If

            Case Windows.Forms.DialogResult.No

                DisplayParameter(New SettingParameter)

        End Select

    End Sub

    Private Sub btnTry_Click(sender As System.Object, e As System.EventArgs) Handles btnTry.Click

        '=== お試し ===
        Try

            If BackupSetting Is Nothing Then '初めての時だけ・・・
                BackupSetting = SettingData.Clone '現在の設定をバックアップ。
                DirectCast(sender, Button).Text &= "*"
            End If

            Decision()
            DirectCast(Owner, FormMain).AllNew()

        Catch ex As Exception

            MessageBox.Show("設定内容の複製に失敗しました。『お試し』できません。" & vbCrLf & vbCrLf & ex.Message, My.Application.Info.Title, MessageBoxButtons.OK, MessageBoxIcon.Error)
            DirectCast(sender, Button).Enabled = False

        End Try

    End Sub

    Private Sub btnOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click

        '=== 決定 ===
        Decision()
        Save()

    End Sub

    Private Sub btnCancel_Click(sender As Object, e As System.EventArgs) Handles btnCancel.Click

        '=== キャンセル ===
        If BackupSetting IsNot Nothing Then
            '--- お試し中なら元に戻す ---
            SettingData = BackupSetting
            DirectCast(Owner, FormMain).AllNew()
        End If

    End Sub

    Private Sub trkRefreshInterval_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles trkRefreshInterval.ValueChanged

        '=== 更新間隔 ===
        '更新間隔は、1ms単位で指定しても意味がなさそうなので、プロパティで単位設定するのではなく計算で行っている。
        With DirectCast(sender, TrackBar)
            .Tag = .Value * ADJUST_INTERVAL
            lblRefreshInterval.Text = .Tag.ToString & "ミリ秒"
        End With

    End Sub

    Private Sub cmbAreaSize_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles cmbAreaWidth.SelectedIndexChanged, cmbAreaHeight.SelectedIndexChanged

        If chkSquareArea.Checked Then
            '=== 正方形設定 ===
            DirectCast(IIf(sender Is cmbAreaWidth, cmbAreaHeight, cmbAreaWidth), ComboBox).SelectedIndex = DirectCast(sender, ComboBox).SelectedIndex
        End If

    End Sub

    Private Sub chkSquareArea_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkSquareArea.CheckedChanged

        '=== 正方形設定の変更 ===
        cmbAreaHeight.SelectedIndex = cmbAreaWidth.SelectedIndex

    End Sub

    Private Sub cbbFoundation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbbFoundation.Click

        '=== 変更対象の選択メニューを表示 ===
        cmsFoundationDesign.Show(cbbFoundation, 0, cbbFoundation.Height)

    End Sub

    Private Sub ColorPickup_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbbMarker.Click, cbbGrid.Click, tsmBack.Click

        '=== カーソルマーカー / 格子線 / 下地背面 色の変更 ===
        With cdlgColorPicker

            Dim target As ColorBoxButton
            If sender Is tsmBack Then
                target = cbbFoundation '下地背面
            Else
                target = sender 'カーソルマーカー / 格子線
            End If

            .Color = target.BoxBackColor
            If .ShowDialog = Windows.Forms.DialogResult.OK Then
                target.BoxBackColor = .Color
            End If

        End With

    End Sub

    Private Sub tsmSlash_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmSlash.Click

        '=== 下地斜線色の変更 ===
        With cdlgColorPicker

            .Color = cbbFoundation.BoxForeColor
            If .ShowDialog = Windows.Forms.DialogResult.OK Then
                cbbFoundation.BoxForeColor = .Color
            End If

        End With

    End Sub

    Private Sub lvwOperationKey_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles lvwOperationKey.SelectedIndexChanged

        '=== 対象を選択 ===
        btnInputKey.Enabled = (DirectCast(sender, ListView).SelectedItems.Count > 0)

    End Sub

    Private Sub btnInputKey_Enter(sender As System.Object, e As System.EventArgs) Handles btnInputKey.Enter

        '=== 入力開始 ===
        DirectCast(sender, Button).Text = "受付中・・・"

        DirectCast(Owner, FormMain).tmrOpeKeyScan.Enabled = False '操作キーを一時停止

    End Sub

    Private Sub btnInputKey_Leave(sender As System.Object, e As System.EventArgs) Handles btnInputKey.Leave

        '=== 入力中止 ===
        With DirectCast(sender, Button)
            .Text = "入力"
            InputtedKey = Keys.None
        End With

        DirectCast(Owner, FormMain).tmrOpeKeyScan.Enabled = True '操作キーを再開（入力に使用したキーに反応してしまうのが欠点）

    End Sub

    Private Sub btnInputKey_PreviewKeyDown(sender As Object, e As System.Windows.Forms.PreviewKeyDownEventArgs) Handles btnInputKey.PreviewKeyDown

        '=== キー入力の有効化 ===
        'これ、すごく重要！！ [KeyDown]では通常受け取れないキー入力を、受け取れるようにする。その代わり、フォーカス移動やコピー・カット＆ペースト等の機能を失う。今回は好都合♪
        e.IsInputKey = True

    End Sub

    Private Sub btnInputKey_KeyDown(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles btnInputKey.KeyDown

        '[PreviewKeyDown]イベントでも、入力できない組み合わせがある（[Control]+[Alt]+[Up]等）。
        'これは、OS等で予約されてるからなのかも？

        Select Case e.KeyCode

            Case Keys.ShiftKey, Keys.ControlKey, Keys.Menu

                '=== 修飾子キーのみが押された時 ===
                InputtedKey = Keys.None

            Case Else

                '=== キーセット取得 ===
                InputtedKey = e.Modifiers Or e.KeyCode '修飾子キーフラグとキーコードを合成

        End Select

        DirectCast(sender, Button).Text = GetString(InputtedKey)

        e.SuppressKeyPress = True

    End Sub

    Private Sub btnInputKey_MouseClick(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles btnInputKey.MouseClick
        '[Space]キー押下をクリックと混同しないように、マウスクリックのみに反応する。

        If InputtedKey <> Keys.None Then

            '=== 入力したキーを登録 ===
            With lvwOperationKey.SelectedItems(0)
                .Tag = InputtedKey
                .SubItems(1).Text = GetString(InputtedKey)
            End With

        End If

    End Sub

    Private Sub cmbColorFormat_TextChanged(sender As System.Object, e As System.EventArgs) Handles cmbColorFormat.TextChanged

        '=== 色書式サンプルを表示 ===
        Try
            lblFormatSample.Text = DirectCast(Me.Owner, FormMain).GetColorString(&HAA112233, DirectCast(sender, ComboBox).Text).Replace(vbCrLf, ENTER_STRING) 'オーナーから文字列をもらう。
        Catch ex As Exception
            lblFormatSample.Text = "エラー"
        End Try

    End Sub

    ''' <summary>
    ''' 現在の設定内容を表示
    ''' </summary>
    ''' <param name="Parameters">表示するパラメータ</param>
    ''' <remarks></remarks>
    Private Sub DisplayParameter(ByVal Parameters As SettingParameter)

        With Parameters

            '=== 拡大鏡 ===
            With .Lupe

                '--- 更新間隔 ---
                trkRefreshInterval.Value = .RefreshInterval \ ADJUST_INTERVAL

                '--- ビューア ---
                With .View

                    '拡大範囲
                    With .Area
                        chkSquareArea.Checked = (.SelectWidthSizeIndex = .SelectHeightSizeIndex) '縦横同じ値が選択されていたら、正方形設定にする。
                        cmbAreaWidth.Items.Clear()
                        cmbAreaHeight.Items.Clear()
                        For Each Item As Integer In .StandardSize
                            cmbAreaWidth.Items.Add(Item.ToString)
                            cmbAreaHeight.Items.Add(Item.ToString)
                        Next
                        cmbAreaWidth.SelectedIndex = .SelectWidthSizeIndex
                        cmbAreaHeight.SelectedIndex = .SelectHeightSizeIndex
                    End With

                    '倍率
                    With .Magnification
                        cmbMagnification.Items.Clear()
                        For Each Item As Integer In .StandardChoices
                            cmbMagnification.Items.Add(Item.ToString)
                        Next
                        cmbMagnification.SelectedIndex = .SelectIndex
                    End With

                    '描画
                    With .Draw
                        chkMarker.Checked = .CursorMarker.Visible
                        cbbMarker.BoxBackColor = .CursorMarker.ForeColor

                        chkGrid.Checked = .Grid.Visible
                        cbbGrid.BoxBackColor = .Grid.ForeColor

                        chkFoundationDesign.Checked = .Foundation.Visible
                        cbbFoundation.BoxForeColor = .Foundation.ForeColor
                        cbbFoundation.BoxBackColor = .Foundation.BackColor
                    End With

                End With

                '--- 情報パネルの形式 ---
                cmbInfoPanelStyle.SelectedValue = .InformationPanel.Style

                '--- マウスからの回避 ---
                cmbAvoidMode.SelectedValue = .Avoid.Mode

            End With

            '=== 操作キー ===
            With .OperationKey

                Dim caption() As String, key() As Keys, newItem(5) As ListViewItem

                caption = New String() {"コマンドパッド呼び出し", "カーソル上", "カーソル下", "カーソル左", "カーソル右", "拡大像コピー"}
                key = New Keys() {.CommandPadCallKey, .DirectKey.CursorUpKey, .DirectKey.CursorDownKey, .DirectKey.CursorLeftKey, .DirectKey.CursorRightKey, .DirectKey.CopyKey}

                For i As Integer = 0 To newItem.Length - 1
                    newItem(i) = New ListViewItem(New String() {caption(i), GetString(key(i))}) With {.Tag = key(i)} '《ToolTipText》プロパティを設定しなくても、はみ出しテキストは自動的に表示してくれるみたい。
                Next

                lvwOperationKey.Items.Clear()
                lvwOperationKey.Items.AddRange(newItem)

            End With

            '=== コマンドパッド ===
            With .CommandPad.ColorFormat

                cmbColorFormat.Items.Clear()
                If .StandardFormat IsNot Nothing Then cmbColorFormat.Items.AddRange(.StandardFormat.ToArray)
                cmbColorFormat.Text = .UseFormat

            End With

        End With

    End Sub

    ''' <summary>
    ''' キーセットを文字列に変換する
    ''' </summary>
    ''' <param name="Keyset">キーセット</param>
    ''' <returns></returns>
    ''' <remarks>[ToString]メソッドでは、綺麗な順番で得られないため</remarks>
    Private Function GetString(Keyset As Keys) As String

        Dim result As String = ""

        If (Keyset And Keys.Shift) = Keys.Shift Then result &= "[Shift] + "
        If (Keyset And Keys.Control) = Keys.Control Then result &= "[Control] + "
        If (Keyset And Keys.Alt) = Keys.Alt Then result &= "[Alt] + "

        result &= "[" & (Keyset And Keys.KeyCode).ToString & "]"

        Return result

    End Function

    ''' <summary>
    ''' 確定
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub Decision()

        With SettingData

            '=== 拡大鏡 ===
            With .Lupe

                '--- 更新間隔 ---
                .RefreshInterval = CInt(trkRefreshInterval.Tag)

                '--- ビューア ---
                With .View

                    '拡大エリア
                    .Area.SelectWidthSizeIndex = cmbAreaWidth.SelectedIndex
                    .Area.SelectHeightSizeIndex = cmbAreaHeight.SelectedIndex

                    '倍率
                    .Magnification.SelectIndex = cmbMagnification.SelectedIndex

                    '描画
                    With .Draw
                        .CursorMarker.Visible = chkMarker.Checked
                        .CursorMarker.ForeColor = cbbMarker.BoxBackColor

                        .Grid.Visible = chkGrid.Checked
                        .Grid.ForeColor = cbbGrid.BoxBackColor

                        .Foundation.Visible = chkFoundationDesign.Checked
                        .Foundation.ForeColor = cbbFoundation.BoxForeColor
                        .Foundation.BackColor = cbbFoundation.BoxBackColor
                    End With

                End With

                '--- 情報パネル ---
                .InformationPanel.Style = cmbInfoPanelStyle.SelectedValue

                '--- マウスからの逃避 ---
                .Avoid.Mode = cmbAvoidMode.SelectedValue

            End With

            '=== 操作キー ===
            With .OperationKey

                .CommandPadCallKey = lvwOperationKey.Items(0).Tag

                With .DirectKey
                    .CursorUpKey = lvwOperationKey.Items(1).Tag
                    .CursorDownKey = lvwOperationKey.Items(2).Tag
                    .CursorLeftKey = lvwOperationKey.Items(3).Tag
                    .CursorRightKey = lvwOperationKey.Items(4).Tag
                    .CopyKey = lvwOperationKey.Items(5).Tag
                End With

            End With

            '=== コマンドパッド ===
            .CommandPad.ColorFormat.UseFormat = cmbColorFormat.Text

        End With

    End Sub

    ''' <summary>
    ''' 設定内容を保存する
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub Save()

        Try

            Windows.Forms.Cursor.Current = Cursors.WaitCursor 'ほとんど処理時間掛からないから要らないけど、おまけ。
            'Throw New Exception("テスト") 'テスト用にエラーを発生させてみる。
            SettingSave()

        Catch ex As Exception

            MessageBox.Show("設定ファイルの保存中に例外が発生しました。" & vbCrLf & vbCrLf & ex.Message, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
            Me.DialogResult = Windows.Forms.DialogResult.None '終了を取り消す

        End Try

    End Sub

End Class